#include "data.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

static char *line;
static int lsize;
static int lmaxsize;

static void pc(int c)
{
  if (lsize == lmaxsize) {
    lmaxsize += 512;
    line = realloc(line, lmaxsize);
    if (!line) OOM;
  }
  line[lsize] = c;
  lsize++;
}

static void get_line(FILE *f)
{
  int c;
  lsize = 0;
  while (1) {
    c = fgetc(f);
    if (c == EOF) break;
    if (c == '\n') break;
    pc(c);
  }
  pc(0);
}

static void add_file(playlist *p, const char *l)
{
  if (p->size == p->maxsize) {
    p->maxsize += 512;
    p->list = realloc(p->list, p->maxsize * sizeof(file));
    if (!p->list) OOM;
  }
  p->list[p->size].name = strdup(l); if (!p->list[p->size].name) OOM;
  p->size++;
}

void load_list(playlist *p, const char *l)
{
  FILE *f;
  int i;

  for (i = 0; i < p->size; i++) free(p->list[i].name);

  p->size = 0;

  if (strcmp(l, "-")) f = fopen(l, "rb");
  else f = stdin;
  if (!f) { perror(l); exit(1); }

  while (1) {
    get_line(f);
    if (lsize == 1) break;
    add_file(p, line);
  }

  if (strcmp(l, "-")) fclose(f);
}
